Option Strict On
Option Explicit On

Imports System.Math
Imports System.Text
Imports System.Runtime.InteropServices

Module misc_examples

    'Example with arrays of Strings as input and output parameters

    Sub g02eece()
        Dim addvar As New Nag_Boolean
        Dim chrss, f, fin, rss As Double
        Dim i, idf, ifr, istep, j, m, _
           maxip, n, nterm, pdq, pdx As Integer
        Dim q() As Double
        Dim wt_ptr As IntPtr
        Dim strResult As New StringBuilder
        Dim fail As New NagError
        Dim order As New Nag_OrderType
        Dim mean_enum As New Nag_IncludeMean
        Dim x_t() As Double = { _
            0, 7, 15, 22, 29, 37, 44, 48, 65, 72, 80, 86, 93, 100, 107, 122, 129, 151, 171, 220, _
            1125, 920, 835, 1000, 1150, 990, 840, 650, 640, 583, 570, 570, 510, 555, 460, 275, 510, 165, 244, 79, _
            232, 268, 271, 237, 192, 202, 184, 200, 180, 165, 151, 171, 243, 147, 286, 198, 196, 210, 327, 334, _
            7160, 8804, 8108, 6370, 6441, 5154, 5896, 5336, 5041, 5012, 4825, 4391, 4320, 3709, 3969, 3558, 4361, 3301, 2964, 2777, _
            85.9, 86.5, 85.2, 83.8, 82.1, 79.2, 81.2, 80.6, 78.4, 79.3, 78.7, 78.0, 72.3, 74.9, 74.4, 72.5, 57.7, 71.8, 72.5, 71.9, _
            8905, 7388, 5348, 8056, 6960, 5690, 6932, 5400, 3177, 4461, 3901, 5002, 4665, 4642, 4840, 4479, 4200, 3410, 3360, 2599}
        Dim y() As Double = {1.5563, 0.8976, 0.7482, 0.716, 0.301, 0.3617, 0.1139, 0.1139, -0.2218, -0.1549, 0.0, 0.0, -0.0969, -0.2218, -0.3979, -0.1549, -0.2218, -0.3979, -0.5229, -0.0458}
        Dim sx() As Integer = {0, 1, 1, 1, 1, 2}
        Dim enc As New System.Text.ASCIIEncoding

        order = Nag_OrderType.Nag_RowMajor

        n = 20
        m = 6
        maxip = m

        Dim x(m * n - 1) As Double

        'convert data (originally from Fortran example) to row order
        '(could use data as-is and specify Nag_ColMajor instead)
        For i = 0 To m - 1
            For j = 0 To n - 1
                x(j * m + i) = x_t(i * n + j)
            Next j
        Next i

        If order = Nag_OrderType.Nag_ColMajor Then
            pdx = n
            pdq = n
            ReDim q(pdq * (maxip + 2) - 1)
        Else
            pdx = m
            pdq = maxip + 2
            ReDim q(pdq * n - 1)
        End If

        Dim exss(maxip - 1) As Double  'maxip
        Dim p(maxip) As Double 'maxip + 1

        'Need to pass null pointer since not providing weights
        'In this instance, we need to change the declaration for g02eec
        'so that it expects an IntPtr (which we can set to nothing)
        'instead of an array of Doubles
        wt_ptr = Nothing

        fin = 2.0
        mean_enum = Nag_IncludeMean.Nag_MeanInclude
        istep = 0

        Dim var_names_ptr_array(m - 1) As IntPtr
        Dim model_ptr_array(maxip - 1) As IntPtr
        Dim free_vars_ptr_array(maxip - 1) As IntPtr
        Dim newvar_ptr(0) As IntPtr  'One element
        Dim vname() As String = {"DAY", "BOD", "TKN", "TS", "TVS", "COD"}
        Dim model_str(maxip - 1) As String
        Dim free_vars_str(maxip - 1) As String
        Dim newvar_str As String

        For i = 0 To m - 1
            var_names_ptr_array(i) = Marshal.StringToHGlobalAnsi(vname(i))
        Next i

        Dim newvar_dummy As String = "123"  'dummy value to get right length of string
        newvar_ptr(0) = Marshal.StringToHGlobalAnsi(newvar_dummy)

        Dim model_dummy As String = "123"
        Dim free_vars_dummy As String = "123"
        For i = 0 To maxip - 1
            model_ptr_array(i) = Marshal.StringToHGlobalAnsi(model_dummy)
            free_vars_ptr_array(i) = Marshal.StringToHGlobalAnsi(free_vars_dummy)
        Next

        strResult.Append("g02eec Example Results" & Environment.NewLine)

        For i = 1 To m
            strResult.Append(Environment.NewLine)

            Call g02eec(order, istep, mean_enum, n, m, x, pdx, _
                var_names_ptr_array, sx, maxip, y, wt_ptr, fin, addvar, _
                newvar_ptr, chrss, f, model_ptr_array, nterm, _
                rss, idf, ifr, free_vars_ptr_array, exss, q, pdq, _
                p, fail)

            If fail.code <> x04ncc("NE_NOERROR") Then
                ' If an error is detected by g02eec, print the error message.
                strResult.Append("g02eec failed with error code " & enc.GetString(fail.message))
                Exit For
            End If

            newvar_str = Marshal.PtrToStringAnsi(newvar_ptr(0))

            For j = 0 To maxip - 1
                model_str(j) = Marshal.PtrToStringAnsi(model_ptr_array(j))
                free_vars_str(j) = Marshal.PtrToStringAnsi(free_vars_ptr_array(j))
            Next j

            strResult.Append("Step " & istep.ToString & Environment.NewLine)
            If addvar = Nag_Boolean.Nag_FALSE Then  'False
                strResult.Append("No further variables added maximum F = " & _
                    f.ToString & Environment.NewLine)
                strResult.Append("Free variables:")
                For j = 0 To ifr - 1
                    strResult.Append("   " & free_vars_str(j))
                Next
                strResult.Append(Environment.NewLine & Environment.NewLine)
                strResult.Append("Change in residual sums of squares for free variables:" _
                    & Environment.NewLine)
                For j = 0 To ifr - 1
                    strResult.Append("   " & exss(j).ToString)
                Next
                strResult.Append(Environment.NewLine)
                Exit For
            Else
                strResult.Append("Added variable is " & newvar_str & Environment.NewLine)
                strResult.Append("Change in residual sum of squares = " _
                    & chrss.ToString & Environment.NewLine)
                strResult.Append("F statistic = " & f.ToString & Environment.NewLine)
                strResult.Append(Environment.NewLine)
                strResult.Append("Variables in model:")
                For j = 0 To nterm - 1
                    strResult.Append("   " & model_str(j))
                Next
                strResult.Append(Environment.NewLine)
                strResult.Append("Residual sum of squares = " & rss.ToString _
                    & Environment.NewLine)
                strResult.Append("Degrees of freedom = " & idf.ToString _
                    & Environment.NewLine)
                strResult.Append(Environment.NewLine)
                If ifr = 0 Then
                    strResult.Append("No free variables remaining" & Environment.NewLine)
                    Exit Sub
                End If
                strResult.Append("Free variables:")
                For j = 0 To ifr - 1
                    strResult.Append("   " & free_vars_str(j))
                Next
                strResult.Append(Environment.NewLine)
                strResult.Append("Change in residual sums of squares for free variables:" _
                    & Environment.NewLine)
                For j = 0 To ifr - 1
                    strResult.Append("   " & exss(j).ToString)
                Next
                strResult.Append(Environment.NewLine)
            End If

        Next i
        MessageBox.Show(strResult.ToString)
        strResult = Nothing

    End Sub

    'Example using Complex

    Sub s17dgce()

        Dim ai As Complex
        Dim z As Complex
        Dim nz As Integer
        Dim scale As Nag_ScaleResType
        Dim deriv As Nag_FunType
        Dim strResult As New StringBuilder
        Dim fail As New NagError
        Dim enc As New System.Text.ASCIIEncoding

        deriv = Nag_FunType.Nag_Function

        z.re = 0.3
        z.im = 0.4

        scale = Nag_ScaleResType.Nag_UnscaleRes

        Call s17dgc(deriv, z, scale, ai, nz, fail)

        If fail.code <> x04ncc("NE_NOERROR") Then
            ' If an error is detected by s17dgc, print the error message.
            strResult.Append("s17dgc failed with error code " & enc.GetString(fail.message))
        Else
            strResult.Append("s17dgc Example Results" & Environment.NewLine & Environment.NewLine)
            strResult.Append("ai = (" & ai.re.ToString & ", " & _
                ai.im.ToString & ")" & Environment.NewLine)
            strResult.Append("nz = " & nz.ToString & Environment.NewLine)
            strResult.Append("fail = " & fail.code.ToString & Environment.NewLine)
        End If
        MessageBox.Show(strResult.ToString)
        strResult = Nothing

    End Sub

    'Example illustrating function pointers

    ' Skeleton for call-back function funct of type e04cbc_FUNCT_DELEGATE
    ' Sub funct( _
    '   ByVal n As Integer, _
    '   ByVal ptr_xc As IntPtr, _
    '   ByRef fc As Double, _
    '   ByRef comm As Nag_Comm _
    ' )
    ' Insert code here.
    ' End Sub

    Sub funct(ByVal n As Integer, ByVal ptr_x As IntPtr, ByRef obj As Double, ByRef comm As Nag_Comm)
        Dim x(n - 1) As Double
        'Copy elements pointed to by ptr_x into local array x.
        Call Marshal.Copy(ptr_x, x, 0, n)
        ' The array x can now be used.
        obj = Exp(x(0)) * (x(0) * 4.0# * (x(0) + x(1)) + x(1) * 2.0# * (x(1) + 1.0#) + 1.0#)
    End Sub

    ' Skeleton for call-back function monit of type e04cbc_MONIT_DELEGATE
    ' Sub monit( _
    ' ByVal fmin As Double, _
    ' ByVal fmax As Double, _
    ' ByVal sim_rptr As IntPtr, _
    ' ByVal n As Integer, _
    ' ByVal ncall As Integer, _
    ' ByVal serror As Double, _
    ' ByVal vratio As Double, _
    ' ByRef comm As Nag_Comm _
    ' )
    ' Insert code here.
    ' End Sub

    Sub monit(ByVal fmin As Double, ByVal fmax As Double, _
        ByVal ptr_sim As IntPtr, ByVal n As Integer, ByVal ncall As Integer, _
        ByVal serror As Double, ByVal vratio As Double, _
        ByRef comm As Nag_Comm)
        Dim sim((n + 1) * n - 1) As Double
        Dim i, j As Integer
        Dim simplx As New StringBuilder
        'Copy elements pointed to by ptr_sim into local array sim.
        Call Marshal.Copy(ptr_sim, sim, 0, (n + 1) * n)
        Try
            ' Set and open file for output
            Dim outputWriter As New System.IO.StreamWriter("C:\e04cbce_output.r")
            ' Print monitoring information to output file
            outputWriter.WriteLine("There have been " & ncall & " function calls")
            outputWriter.WriteLine()
            outputWriter.WriteLine("The smallest function value is " & fmin)
            outputWriter.WriteLine()
            For i = 1 To n + 1
                For j = 1 To n
                    simplx.Append(sim((j - 1) * (n + 1) + i - 1) & "  ")
                Next j
                simplx.Append(Environment.NewLine)
            Next i
            outputWriter.WriteLine("The simplex is")
            outputWriter.Write(simplx.ToString)
            outputWriter.WriteLine()
            outputWriter.WriteLine("The standard deviation in function values at the" _
                   & " vertices of the simplex is " & serror)
            outputWriter.WriteLine()
            outputWriter.WriteLine("The linearized volume ratio of the current simplex" _
                   & " to the starting one is " & vratio)
            ' Close output file
            outputWriter.Close()
        Catch ex As Exception  ' e.g. if it can't open or write to the file
            Exit Sub
        End Try
    End Sub

    Sub e04cbce()
        Dim objf, tolf, tolx As Double
        Dim n, maxcal As Integer
        Dim strResult As New StringBuilder
        Dim comm As New Nag_Comm
        Dim fail As New NagError
        Dim enc As New System.Text.ASCIIEncoding

        n = 2
        Dim x(n - 1) As Double
        x(0) = 0.4
        x(1) = -0.8
        tolf = 0.00000001
        tolx = 0.0
        maxcal = 1500

        Call e04cbc(n, x, objf, tolf, tolx, AddressOf funct, AddressOf monit, maxcal, comm, fail)

        If fail.code <> x04ncc("NE_NOERROR") And fail.code <> x04ncc("NW_TOO_MANY_FEVALS") Then
            ' If an error is detected by e04cbc, print the error message.
            strResult.Append("e04cbc failed with error code " & enc.GetString(fail.message))
        Else
            If fail.code = x04ncc("NW_TOO_MANY_FEVALS") Then
                strResult.Append("e04cbc completed with warning code " & enc.GetString(fail.message) & _
                Environment.NewLine & Environment.NewLine)
            End If
            strResult.Append("e04cbc Example Results" & Environment.NewLine & Environment.NewLine)
            strResult.Append("Final solution: x(0) = " & x(0).ToString & _
                ", x(1) = " & x(1).ToString & Environment.NewLine)
            strResult.Append("Final function value: objf = " & _
                objf.ToString & Environment.NewLine)
        End If
        MessageBox.Show(strResult.ToString)
        strResult = Nothing

    End Sub

    'Floating point control word example

    Sub x03aawx()
        Dim oldcw, newcw As Integer
        Dim strResult As New StringBuilder

        strResult.Append("x03aaw / x03aax Results" & Environment.NewLine & Environment.NewLine)

        Call x03aaw(oldcw)  'Set control word to NAG values; save orig value
        Call x03aaw(newcw)  'Call x03aaw again to return value CW has been set to
        Call x03aax(oldcw)  'Restore original control word

        strResult.Append("Original value of control word is " & Hex(oldcw) & Environment.NewLine & Environment.NewLine)
        strResult.Append("Control word gets set to " & Hex(newcw) & " by x03aaw" & Environment.NewLine & Environment.NewLine)
        strResult.Append("Original control word is restored by x03aax" & Environment.NewLine & Environment.NewLine)

        MessageBox.Show(strResult.ToString)
        strResult = Nothing

    End Sub

    'Two examples with Complex arrays

    Sub f04cece()
        Dim uplo As Nag_UploType = Nag_UploType.Nag_Upper
        Dim order As Nag_OrderType = Nag_OrderType.Nag_ColMajor
        Dim errbnd As Double, rcond As Double
        Dim n As Integer, nrhs As Integer, pdb As Integer
        Dim strResult As New StringBuilder
        Dim fail As New NagError
        Dim rcond_est As Double
        Dim enc As New System.Text.ASCIIEncoding

        n = 4
        nrhs = 2
        pdb = n

        Dim ap(CInt((n * (n + 1)) / 2 - 1)) As Complex
        Dim b(pdb * nrhs - 1) As Complex

        'Set Matrix A
        ap(0).re = 3.23
        ap(0).im = 0.0#

        ap(1).re = 1.51
        ap(1).im = -1.92
        ap(2).re = 3.58
        ap(2).im = 0.0#

        ap(3).re = 1.9
        ap(3).im = 0.84
        ap(4).re = -0.23
        ap(4).im = 1.11
        ap(5).re = 4.09
        ap(5).im = 0.0#

        ap(6).re = 0.42
        ap(6).im = 2.5
        ap(7).re = -1.18
        ap(7).im = 1.37
        ap(8).re = 2.33
        ap(8).im = -0.14
        ap(9).re = 4.29
        ap(9).im = 0.0#

        'Set Matrix B of RHS
        '1st column
        b(0).re = 3.93
        b(0).im = -6.14
        b(1).re = 6.17
        b(1).im = 9.42
        b(2).re = -7.17
        b(2).im = -21.83
        b(3).re = 1.99
        b(3).im = -14.38
        '2nd column
        b(4).re = 1.48
        b(4).im = 6.58
        b(5).re = 4.65
        b(5).im = -4.75
        b(6).re = -4.91
        b(6).im = 2.29
        b(7).re = 7.64
        b(7).im = -10.79

        'Solve the equations Ax=B for x

        'Suppress output
        fail.dnprint = Nag_Boolean.Nag_FALSE

        Call f04cec(order, uplo, n, nrhs, ap, b, pdb, rcond, errbnd, fail)

        If fail.code <> x04ncc("NE_NOERROR") Then
            ' If an error is detected by f04cec, print the error message.
            strResult.Append("f04cec failed with error code " & enc.GetString(fail.message))
        Else
            rcond_est = 1 / rcond  ' since rcond is reciprocal of condition number

            strResult.Append("f04cec Example Results" & Environment.NewLine & Environment.NewLine)

            strResult.Append("Solution(s)" & Environment.NewLine & Environment.NewLine)

            strResult.Append("(" & (b(0).re).ToString & ", ")
            strResult.Append((b(0).im).ToString & ")    ")
            strResult.Append("(" & (b(4).re).ToString & ", ")
            strResult.Append((b(4).im).ToString & ")" & Environment.NewLine)

            strResult.Append("(" & (b(1).re).ToString & ", ")
            strResult.Append((b(1).im).ToString & ")    ")
            strResult.Append("(" & (b(5).re).ToString & ", ")
            strResult.Append((b(5).im).ToString & ")" & Environment.NewLine)

            strResult.Append("(" & (b(2).re).ToString & ", ")
            strResult.Append((b(2).im).ToString & ")    ")
            strResult.Append("(" & (b(6).re).ToString & ", ")
            strResult.Append((b(6).im).ToString & ")" & Environment.NewLine)

            strResult.Append("(" & (b(3).re).ToString & ", ")
            strResult.Append((b(3).im).ToString & ")    ")
            strResult.Append("(" & (b(7).re).ToString & ", ")
            strResult.Append((b(7).im).ToString & ")" & Environment.NewLine & Environment.NewLine)

            strResult.Append("rcond_est: " & rcond_est.ToString & Environment.NewLine)

            strResult.Append("errbnd: " & errbnd.ToString)
        End If

        MessageBox.Show(strResult.ToString)
        strResult = Nothing

    End Sub

    Sub f04cfce()
        Dim uplo As Nag_UploType = Nag_UploType.Nag_Upper
        Dim order As Nag_OrderType = Nag_OrderType.Nag_ColMajor
        Dim errbnd As Double, rcond As Double
        Dim kd As Integer, n As Integer, nrhs As Integer
        Dim pdab As Integer, pdb As Integer
        Dim strResult As New StringBuilder
        Dim rcond_est As Double
        Dim fail As New NagError
        Dim enc As New System.Text.ASCIIEncoding

        n = 4
        kd = 1
        nrhs = 2
        pdab = kd + 1
        pdb = n

        Dim ab(pdab * n - 1) As Complex
        Dim b(nrhs - 1, pdb - 1) As Complex

        'Set Matrix A
        ab(1).re = 9.39
        ab(1).im = 0.0#

        ab(2).re = 1.08
        ab(2).im = -1.73
        ab(3).re = 1.69
        ab(3).im = 0.0#

        ab(4).re = -0.04
        ab(4).im = 0.29
        ab(5).re = 2.65
        ab(5).im = 0.0#

        ab(6).re = -0.33
        ab(6).im = 2.24
        ab(7).re = 2.17
        ab(7).im = 0.0#

        'It is also possible to use 2D arrays.
        'In this instance, we need to change the declaration for f04cfc
        'so that it expects Complex(,) instead of Complex().
        'Set Matrix B of RHS
        b(0, 0).re = -12.42
        b(0, 0).im = 68.42
        b(1, 0).re = 54.3
        b(1, 0).im = -56.56

        b(0, 1).re = -9.93
        b(0, 1).im = 0.88
        b(1, 1).re = 18.32
        b(1, 1).im = 4.76

        b(0, 2).re = -27.3
        b(0, 2).im = -0.01
        b(1, 2).re = -4.4
        b(1, 2).im = 9.97

        b(0, 3).re = 5.31
        b(0, 3).im = 23.63
        b(1, 3).re = 9.43
        b(1, 3).im = 1.41

        'Solve the equations Ax=B for x

        'Suppress output
        fail.dnprint = Nag_Boolean.Nag_FALSE

        Call f04cfc(order, uplo, n, kd, nrhs, ab, pdab, b, pdb, rcond, errbnd, fail)

        If fail.code <> x04ncc("NE_NOERROR") And fail.code <> x04ncc("NE_RCOND") Then
            ' If an error is detected by f04cfc, print the error message.
            strResult.Append("f04cfc failed with error code " & enc.GetString(fail.message))
        Else
            strResult.Append("f04cfc Example Results" & Environment.NewLine & Environment.NewLine)

            strResult.Append("Solution(s)" & Environment.NewLine & Environment.NewLine)

            strResult.Append("(" & (b(0, 0).re).ToString & ", ")
            strResult.Append((b(0, 0).im).ToString & ")    ")
            strResult.Append("(" & (b(1, 0).re).ToString & ", ")
            strResult.Append((b(1, 0).im).ToString & ")" & Environment.NewLine)

            strResult.Append("(" & (b(0, 1).re).ToString & ", ")
            strResult.Append((b(0, 1).im).ToString & ")    ")
            strResult.Append("(" & (b(1, 1).re).ToString & ", ")
            strResult.Append((b(1, 1).im).ToString & ")" & Environment.NewLine)

            strResult.Append("(" & (b(0, 2).re).ToString & ", ")
            strResult.Append((b(0, 2).im).ToString & ")    ")
            strResult.Append("(" & (b(1, 2).re).ToString & ", ")
            strResult.Append((b(1, 2).im).ToString & ")" & Environment.NewLine)

            strResult.Append("(" & (b(0, 3).re).ToString & ", ")
            strResult.Append((b(0, 3).im).ToString & ")    ")
            strResult.Append("(" & (b(1, 3).re).ToString & ", ")
            strResult.Append((b(1, 3).im).ToString & ")" & Environment.NewLine & Environment.NewLine)

            If fail.code = x04ncc("NE_RCOND") Then
                strResult.Append("rcond (reciprocal): " & rcond.ToString & Environment.NewLine)
            Else  ' NE_NOERROR
                rcond_est = 1 / rcond  ' since rcond is reciprocal of condition number
                strResult.Append("rcond_est: " & rcond_est.ToString & Environment.NewLine)
            End If
            strResult.Append("errbnd: " & errbnd.ToString)
        End If

        MessageBox.Show(strResult.ToString)
        strResult = Nothing

    End Sub

    'Example illustrating char * arguments and return values

    Sub x04nace()
        Dim teststr As String = "Nag_ColMajor"
        Dim testnum As Integer
        Dim strResult As New StringBuilder
        Dim strResult2 As New StringBuilder

        ' pass String to x04nac
        testnum = x04nac(teststr)

        strResult.Append("x04nac Output" & Environment.NewLine & Environment.NewLine)
        If (testnum = -1) Then
            strResult.Append(teststr & " is not recognized as a valid NAG enumeration member name")
        Else
            strResult.Append("The numerical value of " & teststr & " is " & testnum)
        End If
        MessageBox.Show(strResult.ToString)
        strResult = Nothing

        'Call x04nbc to do the opposite
        testnum = 101
        teststr = x04nbc(testnum)

        strResult2.Append("x04nbc Output" & Environment.NewLine & Environment.NewLine)
        If teststr = Nothing Then
            strResult2.Append("Invalid input value: no string corresponding to " & testnum)
        Else
            strResult2.Append("The string corresponding to " & testnum & " is " & teststr)
        End If
        MessageBox.Show(strResult2.ToString)
        strResult2 = Nothing

    End Sub

    'Example of function returning Complex value

    Sub s15ddce()
        Dim w As Complex
        Dim z As Complex
        Dim exit_stat As Integer = 0
        Dim fail As New NagError
        Dim strResult As New StringBuilder
        Dim enc As New System.Text.ASCIIEncoding

        z.re = -1.33
        z.im = -0.54

        w = nag_complex_erfc(z, fail)

        strResult.Append("s15ddc Example Results" & Environment.NewLine & Environment.NewLine)

        If fail.code <> x04ncc("NE_NOERROR") And fail.code <> x04ncc("NE_RCOND") Then
            ' If an error is detected by nag_complex_erfc, print the error message.
            strResult.Append("s15ddc failed with error code " & enc.GetString(fail.message))
        Else
            strResult.Append("w.re = " & w.re & "  w.im = " & w.im)
        End If

        MessageBox.Show(strResult.ToString)
        strResult = Nothing

    End Sub

    'Example of sorting a vector via pointers

    Function compare(ByVal a As IntPtr, ByVal b As IntPtr) As Integer

        Dim x(0) As Double
        Dim y(0) As Double

        Call Marshal.Copy(a, x, 0, 1)
        Call Marshal.Copy(b, y, 0, 1)

        If x(0) < y(0) Then
            Return -1
        ElseIf x(0) > y(0) Then
            Return 1
        Else    ' x = y
            Return 0
        End If

    End Function

    Sub m01csce()
        Const MMAX As Short = 20
        Const NMAX As Short = 20

        Dim vec(MMAX - 1, NMAX - 1) As Double
        Dim i, n, m, j, k As Integer
        Dim fail As New NagError
        Dim strInput As New StringBuilder
        Dim strResult As New StringBuilder
        Dim strResult2 As New StringBuilder
        Dim sz As Integer
        Dim vecptr As IntPtr
        Dim vec1d_len As Integer = MMAX * NMAX - 1
        Dim vec1d(vec1d_len) As Double
        Dim vec1d_k(vec1d_len) As Double
        Dim gch As GCHandle
        Dim lastidx As Integer

        fail.dnprint = Nag_Boolean.Nag_TRUE

        m = 12
        n = 3
        k = 2

        vec(0, 0) = 6.0 : vec(0, 1) = 5.0 : vec(0, 2) = 4.0
        vec(1, 0) = 5.0 : vec(1, 1) = 2.0 : vec(1, 2) = 1.0
        vec(2, 0) = 2.0 : vec(2, 1) = 4.0 : vec(2, 2) = 9.0
        vec(3, 0) = 4.0 : vec(3, 1) = 9.0 : vec(3, 2) = 6.0
        vec(4, 0) = 4.0 : vec(4, 1) = 9.0 : vec(4, 2) = 5.0
        vec(5, 0) = 4.0 : vec(5, 1) = 1.0 : vec(5, 2) = 2.0
        vec(6, 0) = 3.0 : vec(6, 1) = 4.0 : vec(6, 2) = 1.0
        vec(7, 0) = 2.0 : vec(7, 1) = 4.0 : vec(7, 2) = 6.0
        vec(8, 0) = 1.0 : vec(8, 1) = 6.0 : vec(8, 2) = 4.0
        vec(9, 0) = 9.0 : vec(9, 1) = 3.0 : vec(9, 2) = 2.0
        vec(10, 0) = 6.0 : vec(10, 1) = 2.0 : vec(10, 2) = 5.0
        vec(11, 0) = 4.0 : vec(11, 1) = 9.0 : vec(11, 2) = 6.0

        strInput.Append("m01csc Example" & Environment.NewLine & Environment.NewLine)
        strInput.Append("Matrix on input" & Environment.NewLine & Environment.NewLine)
        For i = 0 To m - 1
            For j = 0 To n - 1
                strInput.Append(vec(i, j).ToString & "  ")
            Next
            strInput.Append(Environment.NewLine)
        Next
        MessageBox.Show(strInput.ToString)

        'Set up 1d array
        For i = 0 To MMAX - 1
            For j = 0 To NMAX - 1
                vec1d(i * NMAX + j) = vec(i, j)
            Next
        Next

        sz = Len(vec(0, 0))

        'We want to pass a stable pointer to vec
        'In this instance, we need to change the declaration for m01csc
        'so that it expects an IntPtr instead of an array of pointers
        gch = GCHandle.Alloc(vec, GCHandleType.Pinned)
        vecptr = gch.AddrOfPinnedObject()

        'This works if we want to sort the 1st column (k = 1)
        m01csc(vecptr, m, sz, CType(sz * NMAX, IntPtr), AddressOf compare, Nag_SortOrder.Nag_Ascending, fail)

        strResult.Append("m01csc Example" & Environment.NewLine & Environment.NewLine)

        If fail.code <> x04ncc("NE_NOERROR") Then
            strResult.Append("m01csc failed when sorting 1st column" & Environment.NewLine)
            'fail.dnprint is true, so error message should be printed from within routine
        Else
            strResult.Append("Matrix with sorted 1st column" & Environment.NewLine & Environment.NewLine)
            For i = 0 To m - 1
                For j = 0 To n - 1
                    strResult.Append(vec(i, j).ToString & "  ")
                Next j
                strResult.Append(Environment.NewLine)
            Next i
        End If

        MessageBox.Show(strResult.ToString)
        strResult = Nothing
        'GCHandle must be explicitly released to avoid memory leaks
        gch.Free()

        'We actually want start of column k (1-based)

        lastidx = vec1d_len - k  '= vec1d_len - 1 - (k - 1)
        For i = 0 To lastidx
            vec1d_k(i) = vec1d(i + k - 1)
        Next i

        gch = GCHandle.Alloc(vec1d_k, GCHandleType.Pinned)
        vecptr = gch.AddrOfPinnedObject()

        m01csc(vecptr, m, sz, CType(sz * NMAX, IntPtr), AddressOf compare, Nag_SortOrder.Nag_Ascending, fail)

        strResult2.Append("m01csc Example" & Environment.NewLine & Environment.NewLine)

        If fail.code <> x04ncc("NE_NOERROR") Then
            strResult2.Append("m01csc failed when sorting kth column for k = " & k.ToString & Environment.NewLine)
            'fail.dnprint is true, so error message should be printed from within routine
        Else
            'Copy changed values back
            For i = 0 To lastidx
                vec1d(i + k - 1) = vec1d_k(i)
            Next
            For i = 0 To MMAX - 1
                For j = 0 To NMAX - 1
                    vec(i, j) = vec1d(i * NMAX + j)
                Next
            Next

            strResult2.Append("Matrix with sorted kth column for k = " & k.ToString & Environment.NewLine & Environment.NewLine)
            For i = 0 To m - 1
                For j = 0 To n - 1
                    strResult2.Append(vec(i, j).ToString & "  ")
                Next j
                strResult2.Append(Environment.NewLine)
            Next i
        End If

        MessageBox.Show(strResult2.ToString)
        strResult2 = Nothing
        gch.Free()

    End Sub

End Module
